"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {};
exports.default = defineSnippet;

var _replace = require("./replace");

var _utils = require("./utils");

var _types = require("./types");

Object.keys(_types).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _types[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _types[key];
    }
  });
});

function defineSnippet(config, snippets) {
  const bodyRecord = (0, _utils.mergeSnippet)(snippets);
  const newSnippet = Object.entries(config).reduce((newSnippet, [snippetName, snippetItem]) => {
    var _snippetItem$extra;

    let tabstopsRecord;

    if ((_snippetItem$extra = snippetItem.extra) !== null && _snippetItem$extra !== void 0 && _snippetItem$extra.tabstops) {
      var _snippetItem$extra2;

      tabstopsRecord = (0, _replace.getTabstopsRecord)((_snippetItem$extra2 = snippetItem.extra) === null || _snippetItem$extra2 === void 0 ? void 0 : _snippetItem$extra2.tabstops);
    }

    const newBodyRecord = Object.entries(bodyRecord).reduce((bodyRecord, [snippetName, body]) => {
      bodyRecord[snippetName] = body.map(code => (0, _replace.replaceTabstops)(code, snippetName, {
        tabstopsRecord
      }));
      return bodyRecord;
    }, {});
    let body = snippetItem.body.map(code => (0, _replace.replaceBody)(code, {
      bodyRecord: newBodyRecord
    }));
    body = body.map(code => {
      var _snippetItem$extra3;

      return (0, _replace.replaceCustomVar)(code, {
        customVarRecord: (_snippetItem$extra3 = snippetItem.extra) === null || _snippetItem$extra3 === void 0 ? void 0 : _snippetItem$extra3.customVar
      });
    });
    const newSnippetItem = {
      prefix: snippetItem.prefix,
      scope: snippetItem.scope,
      description: snippetItem.description,
      body
    };
    newSnippet[snippetName] = newSnippetItem;
    return newSnippet;
  }, {});
  return newSnippet;
}